<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\lists\shops;


use app\adminapi\lists\BaseAdminDataLists;
use app\common\model\shops\ShopCategory;
use app\common\lists\ListsSearchInterface;


/**
 * ShopCategory列表
 * Class ShopCategoryLists
 * @package app\adminapi\listsshops
 */
class ShopCategoryLists extends BaseAdminDataLists implements ListsSearchInterface
{


    /**
     * @notes 设置搜索条件
     * @return \string[][]
     * @author likeadmin
     * @date 2024/08/04 10:42
     */
    public function setSearch(): array
    {
        return [
            '=' => ['name', 'status'],

        ];
    }


    /**
     * @notes 获取列表
     * @return array
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     * @author likeadmin
     * @date 2024/08/04 10:42
     */
    public function lists(): array
    {
        $lists = ShopCategory::where($this->searchWhere)
            ->field(['id', 'pid', 'picture', 'name', 'status', 'weigh'])
            ->order(['weigh' => 'desc'])
            ->select()
            ->toArray();

        return linear_to_tree($lists, 'children', 'id', 'pid');
    }


    /**
     * @notes 获取数量
     * @return int
     * @author likeadmin
     * @date 2024/08/04 10:42
     */
    public function count(): int
    {
        return ShopCategory::where($this->searchWhere)->count();
    }

}